import csv

fichier_entree = "res6_Random.csv" # fichier sans colonne Bin
fichier_sortie = "res7_Random.csv" # fichier qui sera extrait avec la colonne Bin

donnees = []

# Lire les données
with open(fichier_entree, mode="r", encoding="utf-8") as f:
    reader = csv.DictReader(f)
    for row in reader:
        mot = row["Mot"]
        train = int(row["Train"])
        val = int(row["Val"])
        test = int(row["Test"])
        donnees.append([mot, train, val, test])

donnees_tries = sorted(donnees, key=lambda x: x[1], reverse=True)

# Calculer la somme totale
somme_train = sum(row[1] for row in donnees_tries)
print(f"Somme totale de Train : {somme_train}")

# Calcul des bins
cumul = 0
donnees_binees = []
for row in donnees_tries:
    mot, train, val, test = row
    cumul += train
    pourcentage = (cumul / somme_train) * 100
    bin_pourcent = min(100, ((int(pourcentage) // 10) + 1) * 10)  # 10, 20, ..., 100
    donnees_binees.append([mot, train, val, test, bin_pourcent])

# Sauvegarder dans un nouveau fichier
with open(fichier_sortie, mode="w", newline="", encoding="utf-8") as f_out:
    writer = csv.writer(f_out)
    writer.writerow(["Mot", "Train", "Val", "Test", "Bin"])  # Ajout de la colonne Bin
    writer.writerows(donnees_binees)

print(f"Fichier '{fichier_sortie}' généré avec succès.")


